/* SPDX-License-Identifier: GPL-2.0-only */
/* Copyright (c) 2023, Intel Corporation. */

#ifndef _IDPF_PTP_H_
#define _IDPF_PTP_H_

#include <linux/clocksource.h>
#include <linux/net_tstamp.h>
#include <linux/ptp_clock_kernel.h>
#include <linux/ptp_classify.h>

struct idpf_ptp_regs {
	int exec_cmd_mask;
	int shtime_enable_mask;
};

struct idpf_ptp {
	struct ptp_clock_info info;
	struct ptp_clock *clock;
	struct idpf_ptp_regs regs;
	struct virtchnl2_get_ptp_caps *caps;
};

int idpf_get_ptp_caps(struct idpf_adapter *adapter);
int idpf_ptp_init(struct idpf_adapter *adpater);
void idpf_ptp_release(struct idpf_adapter *adapter);

#endif /* _IDPF_PTP_H_ */
